package PlayBot::commands::broken;

use strict;
use warnings;

use PlayBot::utils::db;
use PlayBot::utils::db::get;
use PlayBot::utils::print;

use Try::Tiny;

sub exec {
	my ($chan, $id) = @_;
    my $dbh = PlayBot::utils::db::main_session;

    my $query = PlayBot::commands::get::query->new(
        chan => $chan,
        query  => $id,
    );
    my $db_query = PlayBot::utils::db::get->new();
    my $content = $db_query->get($query);

    die("La cuillère n'existe pas\n") if (not $content);

    if (not $content->{external_id})
    {
        return "Cette feature n'est pas encore disponible pour ce contenu";
    }


    my $content_r;
    try
    {
        my $site = 'PlayBot::sites::'.$content->{site};
        eval "require $site";
        my %h = $site->get($content->{external_id});
        $content_r = \%h;
    }
    catch
    {
        # mark as broken
        # TODO: be more subtil
        my $sth = $dbh->prepare('
            UPDATE playbot
            SET broken = 1
            WHERE type = ? AND external_id = ?
        ');
		$sth->execute($content->{site}, $content->{external_id});
        $dbh->commit;
        die "Monde de merde\n";
    };

    try
    {
        foreach my $k (keys %$content_r)
        {
            die if($content_r->{$k} ne $content->{$k});
        }
    }
    catch
    {
        # the content needs an update
        my $sth = $dbh->prepare('
            UPDATE playbot SET
            sender = ?,
            title = ?,
            duration = ?,
            url = ?
            WHERE type = ? AND external_id = ?
        ');
        $sth->execute(
            $content_r->{author},
            $content_r->{title},
            $content_r->{duration},
            $content_r->{url},
            $content_r->{site},
            $content_r->{external_id},
        );
        $dbh->commit;

        my $msg = PlayBot::utils::print::print($content);
        die"Ça, c’est bon, c’est réparé\n$msg\n";
    };
    
    return "http://chezmoicamarche.org/";
}


1;
