package PlayBot::sites::deezer;

use strict;
use warnings;

use LWP::UserAgent;
use JSON;
use FindBin;

my $conf;
my $endpoint = "https://api.deezer.com/track/";

sub regex
{
    return qr#(?:^|[^!])https?://(?:www.)?deezer.com/track/([a-zA-Z0-9_-]+)#;
}

sub get {
    shift;
	my $id = shift;
	
    my $ua = LWP::UserAgent->new(
        timeout     => 30,
        env_proxy   => 1,
    );
	my $response = $ua->get($endpoint
        .$id);
	die($response->status_line) unless ($response->is_success);

	my $content = decode_json($response->decoded_content);

#    die "video not found" if (not scalar @{ $content->{items} });
    
    my %infos;

    $infos{'title'} = $content->{'title'};
    $infos{'duration'} = $content->{'duration'};
	$infos{'site'} = 'deezer';
    $infos{'url'} = 'https://www.deezer.com/track/'.$id;
    $infos{'author'} = $content->{'artist'}->{'name'};
	$infos{'external_id'} = $id;

	return %infos;
}

1;
